<script lang="ts">
// 声明额外的选项
export default {
  name: "Add"
};
</script>
<script setup lang="ts">
import { inject, onMounted, reactive, ref, Uploadfile, UploadImg, Editor, useRenderIcon, ElMessage, ElMessageBox, Upload, Close, http, getGroupUrl, RegularVerification, verification } from "@/utils/importUsed"
// 接口列表实例
let UrlList = reactive(null)
// 获取当前板块接口列表
onMounted(async () => {
  UrlList = await getGroupUrl(["prizeSet"]);

})
// 组件传参对象
const props = defineProps<{
  submit: Function;
  addVisible: {
    type: Boolean;
    default: false;
  };
  width: {
    type: Number;
    default: 50;
  };
}>();
// 表单数据
let UpdateForm = ref({
  terminalKind: "", //终端类型
  versionNum: "", //版本号
  title: "", //标题
  info: "", //更新信息
  confirmText: "", //确定按钮文字
  cancelText: "", //取消按钮文字
  downloadUrl: "", //更新地址
  kind: "", //分类

});
// 表单实例
const ruleFormRef = ref()

// 传参选项数据
// 终端类型选项数据
const terminalKindOptionList = [
  { label: 'ios', id: 'ios' },
  { label: 'android', id: 'android' }
]
// 分类选项数据
const kindOptionList = [
  { label: '创客版', id: 'creater' }
]

// 选项卡参数(默认值为列表某项的id)
const activeId = ref('1')
// 提交函数
const submit = async (formEl) => {
  // 表单校验拦截
  if (!formEl) return
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      //表单校验成功回调
      console.log('submit!')


      // 需动态生成接口
      const { status, msg }: any = await http.Request({
        method: UrlList.prizeSet.appVersionadd.method,
        url: UrlList.prizeSet.appVersionadd.url,
        params: UpdateForm.value
      });
      if (status === 1) {
        //业务成功回调
        ElMessage({
          message: "新增成功",
          type: "success"
        });
        UpdateForm.value = {
          terminalKind: "", //终端类型
          versionNum: "", //版本号
          title: "", //标题
          info: "", //更新信息
          confirmText: "", //确定按钮文字
          cancelText: "", //取消按钮文字
          downloadUrl: "", //更新地址
          kind: "", //分类

        };
        // 关闭新增弹窗;
        closeVisible()
      } else {
        //业务失败回调
        ElMessageBox.alert(msg, "提示", {
          confirmButtonText: "关闭",
          type: "warning"
        });
      }
    } else {
      //表单校验失败回调
      ElMessage({
        message: "请输入完整信息",
        type: "error"
      });
    }
  })
};




// 表单校验规则
const rules = reactive({
  kind: [
    { required: true, message: '请输入分类', trigger: 'blur' },
  ],

})
// 关闭弹窗回调函数
const closeFn: any = inject("closeAddVisible");
const closeVisible = () => {
  // 清空表单项;
  UpdateForm.value = {
    terminalKind: "", //终端类型
    versionNum: "", //版本号
    title: "", //标题
    info: "", //更新信息
    confirmText: "", //确定按钮文字
    cancelText: "", //取消按钮文字
    downloadUrl: "", //更新地址
    kind: "", //分类

  };
  closeFn();
};

// 弹窗是否全屏
const isFullscreen = ref(false)
</script>

<template lang="pug">
.main
  el-dialog(v-model='props.addVisible' width="50%" :fullscreen="isFullscreen" title="新增" draggable @close="closeVisible")
    el-tabs(v-model="activeId" class="demo-tabs" @tab-click="handleClick")
      el-tab-pane(label="基本资料" name="1")
        el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
          el-form-item(label="终端类型", prop="terminalKind")
            el-select(
              v-model="UpdateForm.terminalKind",
              placeholder="请选择终端类型",
              clearable,
            )
              el-option(:label="item.label", :value="item.id" v-for="(item,index) in terminalKindOptionList")
          el-form-item(label='版本号' prop="versionNum")
            el-input(v-model='UpdateForm.versionNum' autocomplete='off'
              placeholder="请输入版本号")
          el-form-item(label='标题' prop="title")
            el-input(v-model='UpdateForm.title' autocomplete='off'
              placeholder="请输入标题")
          el-form-item(label='确定按钮文字' prop="confirmText")
            el-input(v-model='UpdateForm.confirmText' autocomplete='off'
              placeholder="请输入确定按钮文字")
          el-form-item(label='取消按钮文字' prop="cancelText")
            el-input(v-model='UpdateForm.cancelText' autocomplete='off'
              placeholder="请输入取消按钮文字")
          el-form-item(label='更新地址' prop="downloadUrl")
            el-input(v-model='UpdateForm.downloadUrl' autocomplete='off'
              placeholder="请输入更新地址")
      el-tab-pane(label="基本信息" name="2")
        el-form(:model='UpdateForm' label-position="right" ref="ruleFormRef" :rules="rules" label-width="100px")
          el-form-item(label="分类", prop="kind")
            el-select(
              v-model="UpdateForm.kind",
              placeholder="请选择分类",
              clearable,
            )
              el-option(:label="item.label", :value="item.id" v-for="(item,index) in kindOptionList")
    el-tabs(v-model="activeId" class="demo-tabs" @tab-click="handleClick")

    .flex.justify-end
      el-button(
        :icon="useRenderIcon(Close)",
        @click="closeVisible"
      ) 关闭
      el-button(
        type="primary",
        :icon="useRenderIcon(Upload)",
        @click="submit(ruleFormRef)"
      ) 确认提交
</template>

<style scoped lang="scss">
:deep(.el-dropdown-menu__item i) {
  margin: 0;
}

:deep(.el-form-item__label) {
  font-weight: 700;
}

:deep(.el-pagination) {
  flex-flow: wrap;
}

:deep(.is-draggable) {
  max-height: 80vh;
  overflow: auto;
}

:deep(.el-dialog__header) {
  position: sticky;
  top: 0;
  z-index: 2;
  background: #fff;
}

.collapsedom {
  padding: 0 20px;
  background-color: #fff;
}

.ovh-x {
  height: 40vh;
  overflow-y: auto;
}

:deep(.el-descriptions__header) {
  margin: 16px 0 !important;
}

.el-select {
  width: 100%;
}
</style>
